/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap;

import com.bbn.openmap.Layer;
import com.bbn.openmap.LayerHandler;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.ThematicDataDisplayLayer;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Thematic;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *LayerHandler used only for the atlas mode
 * @author jchauvea
 */
public class AtlasLayerHandler extends LayerHandler {




    protected HashMap<Layer, LayerNameAndProps> loadableLayers = new HashMap<Layer, LayerNameAndProps>();

    public void addLoadableLayer(Layer layer, String name, Properties props) {
        //System.out.println(hashCode() + " ----- AJOUT LOADABLE LAYER" + layer.getClass() + " - " + layer.hashCode());
        loadableLayers.put(layer, new LayerNameAndProps(name, props));
    }


    public void loadLayer(Layer l){
        //String tmpName = l.getName();
        //System.out.println("loadable layer" + loadableLayers.get(l).getProperties());
        l.setProperties(l.getName(),loadableLayers.get(l).getProperties());
        l.setVisible(true);      
        addLayer(l);
        setLayers();

        //l.setName(tmpName);
    }

    public void /*Layer*/ unloadLayer(Layer l){
//        removeLayer(l);
//        //System.out.println("CONTAINS "+ l.hashCode()+"? " + loadableLayers.containsKey(l));
//        LayerNameAndProps nAndP = loadableLayers.get(l);
//        Properties props = nAndP.getProperties();
//        //System.out.println("properties = " + props);
//        //System.out.println(hashCode() + " ----- UNLOAD LAYER" + l.getClass() + " - " + l.hashCode() + "props = " + props);
//        loadableLayers.remove(l);
//       // System.out.println("CLASSE NAME = "  + l.getName());
//        String classProperty = nAndP.getName() + ".class";
//        String className = props.getProperty(classProperty);
//        //System.out.println("CLASSE A CHARGER = "  + className);
//        try {
//            Layer layer = (Layer) java.beans.Beans.instantiate(null, className);
//            loadableLayers.put(layer,nAndP);
//            layer.setName(nAndP.getName());
//            return layer;
//        } catch (IOException ex) {
//            Logger.getLogger(AtlasLayerHandler.class.getName()).log(Level.SEVERE, className, ex);
//        } catch (ClassNotFoundException ex) {
//            Logger.getLogger(AtlasLayerHandler.class.getName()).log(Level.SEVERE, className, ex);
//        }
//        return null;
        removeLayer(l);
        LayerNameAndProps nAndP = loadableLayers.get(l);
        String lname = nAndP.getName();

        Properties props = new Properties();
        props.put(lname+".visuNames", "##");
        l.setProperties(props);
        l.setName(lname);
        //addLayer(l);
    }

    @Override
    public void removeLayer(Layer l){
    super.removeLayer(l);
    if(l instanceof ThematicDataDisplayLayer){
        ThematicDataDisplayLayer tddl = (ThematicDataDisplayLayer)l;
        int size = tddl.getThematicArray().size();
        for(int i = 0 ; i < size; i++){
            tddl.deleteThematicVisu(tddl.getThematicArray().get(0));

        }
    }

    }

    @Override
    public boolean turnLayerOn(boolean b, Layer l){
        if(b)
            loadLayer(l);
        return true;
    }


    class LayerNameAndProps{
        private String name;
        private Properties properties;

    public LayerNameAndProps(String n, Properties p){
        this.name = n;
        this.properties = p;
    }


    public String getName(){
        return name;
    }


    public Properties getProperties(){
        return properties;
    }
    }


}
