/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.animation.gui;

import com.bbn.openmap.I18n;
import com.bbn.openmap.Layer;
import com.bbn.openmap.LayerHandler;
import com.bbn.openmap.event.LayerEvent;
import fr.unicaen.openmap.Environment;
import fr.unicaen.openmap.animation.AnimationDSChain;
import fr.unicaen.openmap.dataStorage.MonoValuedFilterDataStorage;
import fr.unicaen.openmap.dataStorage.SortDataStorage;
import fr.unicaen.openmap.event.LayerListener;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.ThematicDataDisplayLayer;
import fr.unicaen.openmap.util.Util;
import fr.unicaen.openmap.util.gui.ComponentSizer;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.HashMap;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.JToggleButton;
import javax.swing.JToolBar;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


/**
 *
 * @author dje
 */
public class AnimationDSChainPanel extends JPanel implements LayerListener {

    private AnimationDSChain dsChain;
    private JPanel toolGUI;
    private JToolBar toolButtons;
    private JComboBox cbValues, cbValuesTool;
    private JSpinner spinnerDelay;
    private JToggleButton bRun, bRunTool;
    private JButton nextButton, nextButtonTool;
    private JButton bRemoveChain;
    private JButton bNewAnim;
    private JButton bShowTool;
    private boolean asc;
    //private JButton bSort;
    private JPanel pAddAnim;
    private JComboBox comboboxLayers, boxFormat;
    private SortDataStorage.Format selectedFormat = SortDataStorage.Format.STRING;
    private ActionListener manualActionListener;//, manualActionListenerTool;
    protected I18n i18n = Environment.getI18n();
    private Box listBox;
    //private JCheckBox sortCheckBox;
    private JRadioButton bAsc, bDesc;
    private HashMap<MonoValuedFilterDataStorage, JComponent> animationsGUI;
    private boolean activeListener;

    public AnimationDSChainPanel(AnimationDSChain dsc) {
        super(new BorderLayout());
        this.dsChain = dsc;
        activeListener = true;
        animationsGUI = new HashMap<MonoValuedFilterDataStorage, JComponent>();
        manualActionListener = new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                if(!activeListener)
                    return;
                JComboBox source = (JComboBox) e.getSource();
                if (source.getSelectedItem() != null) {
                    String item = source.getSelectedItem().toString();
                    dsChain.nextStep(item);
                    for (MonoValuedFilterDataStorage ads : dsChain.getAnimationDatastorages()) {
                        ads.updateValue(item);
                    }
                    activeListener = false;
                    if(source == cbValues)
                        cbValuesTool.setSelectedItem(item);
                    else
                        cbValues.setSelectedItem(item);
                    activeListener = true;
                }
            }
        };

        cbValues = new JComboBox(dsc.computeUnionValues().toArray());
        listBox = Box.createVerticalBox();

        for(MonoValuedFilterDataStorage ads : dsChain.getAnimationDatastorages())
            addAnimationGUI(ads);
        for (MonoValuedFilterDataStorage ads : dsChain.getMetaAnimator().getAvailableDSList()) {
            addAnimationGUI(ads);
        }
        add(listBox, BorderLayout.WEST);
        listBox.setBorder(BorderFactory.createTitledBorder(i18n.get(AnimationDSChainPanel.class, "filters", "Filters")));
        Box panParameters = Box.createVerticalBox();

        cbValues.addActionListener(manualActionListener);
        ComponentSizer.fixComponentSize(cbValues, new Dimension(120, 20));

        ButtonGroup bg = new ButtonGroup();
        bAsc = new JRadioButton();
        bDesc = new JRadioButton();
        bg.add(bAsc);
        bg.add(bDesc);
        ItemListener ascDescListener = new ItemListener() {

            public void itemStateChanged(ItemEvent arg0) {
                asc = bAsc.isSelected();
                bAsc.setIcon(asc ? Util.loadIcon("Up16.png") : Util.loadIcon("Up16-2.png"));
                bDesc.setIcon(asc ? Util.loadIcon("Down16-2.png") : Util.loadIcon("Down16.png"));
                sort();
            }
        };
        bAsc.addItemListener(ascDescListener);
        bDesc.addItemListener(ascDescListener);
        bg.add(bAsc);
        bg.add(bDesc);
//        bAsc.addItemListener(new ItemListener() {
//
//            public void itemStateChanged(ItemEvent arg0) {
//                asc = bAsc.isSelected();
//            }
//        });

        Box wrapSort = Box.createVerticalBox();
        JPanel panSort = new JPanel();
        JPanel wrapCustom = new JPanel();
        wrapSort.add(panSort);
        wrapSort.add(wrapCustom);

//        sortCheckBox = new JCheckBox(i18n.get(AnimationDSChainPanel.class, "sort", "Sort"));
//        sortCheckBox.addActionListener(new ActionListener() {
//
//            public void actionPerformed(ActionEvent arg0) {
//                setEnabledSortGUI(sortCheckBox.isSelected());
//            }
//        });
        boxFormat = new JComboBox(SortDataStorage.Format.values());
        boxFormat.setSelectedItem(selectedFormat);
        JPanel panFormat = new JPanel();
        //sortPanel.add(panOrder);
        //sortPanel.add(panFormat);
        /*panFormat.add(new JLabel(i18n.get(AnimationDSChainPanel.class, "columnFormat", "Column Format ")));*/
        panFormat.add(boxFormat);
        final JLabel labCustom = new JLabel(i18n.get(AnimationDSChainPanel.class, "customFormat", "Custom Format "));
        //sortPanel.add(wrapCustom);
        wrapCustom.add(labCustom);
        final JTextField fieldCustomFormat = new JTextField("");
        wrapCustom.add(fieldCustomFormat);
        labCustom.setVisible(false);
        fieldCustomFormat.setVisible(false);
        ComponentSizer.fixComponentSize(fieldCustomFormat, new Dimension(100, 20));
        ComponentSizer.fixComponentSize(boxFormat, new Dimension(100, 20));
        fieldCustomFormat.addKeyListener(new KeyAdapter() {

            public void keyReleased(KeyEvent evt) {
                selectedFormat.setInnerFormat(fieldCustomFormat.getText());
            }
        });
        boxFormat.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                selectedFormat = (SortDataStorage.Format) ((JComboBox) e.getSource()).getSelectedItem();
                labCustom.setVisible(selectedFormat == SortDataStorage.Format.DATE_CUSTOM);
                fieldCustomFormat.setVisible(selectedFormat == SortDataStorage.Format.DATE_CUSTOM);
                if(bAsc.isSelected() || bDesc.isSelected())
                    sort();
            }
        });

//        bSort = new JButton(i18n.get(AnimationDSChainPanel.class, "apply", "Apply"));
//        bSort.addActionListener(new ActionListener() {
//
//            public void actionPerformed(ActionEvent e) {
//                dsChain.sortValues(selectedFormat, bAsc.isSelected());
//
//            }
//        });
        bAsc.setIcon(Util.loadIcon("Up16-2.png"));
        bDesc.setIcon(Util.loadIcon("Down16-2.png"));
        panFormat.add(bAsc);
        panFormat.add(bDesc);
        //panFormat.add(bSort);

        panSort.add(new JLabel(i18n.get(AnimationDSChainPanel.class, "sort", "Sort")));
        panSort.add(panFormat);

        JPanel panValues = new JPanel();
        panValues.add(new JLabel(i18n.get(AnimationDSChainPanel.class, "values", "Values")));
        nextButton = new JButton(Util.loadIcon("FastForward16.png"));
        nextButton.setToolTipText(i18n.get(AnimationDSChainPanel.class, "next", "Next value"));
        nextButton.addActionListener(dsChain.getNextValueAction());
        panParameters.add(panValues);
        JPanel panTimer = new JPanel();
        spinnerDelay = new JSpinner(new SpinnerNumberModel(dsChain.getDelay(), 0, 60, 1));
        spinnerDelay.addChangeListener(new ChangeListener() {

            public void stateChanged(ChangeEvent e) {
                int del = Integer.parseInt(spinnerDelay.getValue().toString());
                dsChain.setDelay(del);
                if (dsChain.getSlave() != null) {
                    ((AnimationDSChainPanel) (dsChain.getSlave().getGUI())).setDelay(del);
                }
                if (dsChain.getMaster() != null) {
                    ((AnimationDSChainPanel) (dsChain.getMaster().getGUI())).setDelay(del);
                }
            }
        });
        bRun = new JToggleButton(Util.loadIcon("Play16.png"));
        bRun.setBackground(Color.gray);
        bRun.setOpaque(false);
        nextButton.setBackground(Color.gray);
        nextButton.setOpaque(false);
        panValues.add(cbValues);
        panValues.add(nextButton);
        panValues.add(panTimer);
        panTimer.add(bRun);
        panTimer.add(new JLabel(i18n.get(AnimationDSChainPanel.class, "delay", "Delay")));
        panTimer.setBorder(BorderFactory.createLineBorder(Color.gray));
        ComponentSizer.fixComponentSize(bRun, new Dimension(30, 20));

        bRun.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                if (bRun.isSelected()) {
                    dsChain.start();
                    bRun.setIcon(Util.loadIcon("Pause16.png"));
                    setEnabledManualNextButtons(false);
                } else {
                    dsChain.stop();
                    bRun.setIcon(Util.loadIcon("Play16.png"));
                    setEnabledManualNextButtons(true);
                }
                bRun.updateUI();
            }
        });
        panTimer.add(spinnerDelay);
        //panParameters.add(panTimer);
        panParameters.add(wrapSort);
        //panParameters.add(sortTaskContainer);
        add(panParameters, BorderLayout.CENTER);
        panParameters.setBorder(
                BorderFactory.createTitledBorder(""/*
                i18n.get(AnimationDSChainPanel.class, "chainParameters", "Chain parameters")*/));
        bRemoveChain = new JButton(Util.loadIcon("Delete16.png"));
        bRemoveChain.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent arg0) {
                dsChain.delete();
            }
        });
//        if (dsChain.getMetaAnimator().getNbChain() == 1)
//            bRemoveChain.setEnabled(false);
        bRemoveChain.setToolTipText(i18n.get(AnimationDSChainPanel.class, "delete", "delete the chain"));
        bNewAnim = new JButton(Util.loadIcon("addanim.png"));
        bShowTool = new JButton(Util.loadIcon("enabled.png"));
        bNewAnim.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent arg0) {
                addAnimationCreationGUI();
                bNewAnim.setEnabled(false);
            }
        });

        bShowTool.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent arg0) {
                boolean visibility = !dsChain.getToolGUI().isVisible();
                dsChain.getToolGUI().setVisible(visibility);
                bShowTool.setIcon(visibility ? Util.loadIcon("enabled.png") : Util.loadIcon("disabled.png"));
            }
        });

        bNewAnim.setToolTipText(
                i18n.get(AnimationDSChainPanel.class, "addAnimationToLayer", "Add a new animation to a layer"));

        bRemoveChain.setBackground(Color.gray);
        bRemoveChain.setOpaque(false);
        bNewAnim.setBackground(Color.gray);
        bNewAnim.setOpaque(false);

        toolButtons = new JToolBar();
        toolButtons.setFloatable(false);
        toolButtons.add(bNewAnim);
        toolButtons.add(bShowTool);
        toolButtons.add(Box.createRigidArea(new Dimension(20, 20)));
        toolButtons.add(bRemoveChain);
        //bRemoveChain.setBorder(BorderFactory.createEmptyBorder(0, 15, 0, 0));
        ComponentSizer.fixComponentSize(bNewAnim, new Dimension(35, 35));
        ComponentSizer.fixComponentSize(bRemoveChain, new Dimension(35, 35));
        ComponentSizer.fixComponentSize(bShowTool, new Dimension(35, 35));
        add(toolButtons, BorderLayout.NORTH);

        //ComponentSizer.fixComponentSize(wrapTop, new Dimension(680, 30));
        toolGUI = buildToolGUI();

        ComponentSizer.fixComponentSize(this, new Dimension(680, 200));


        setEnabledParametersGUI(dsChain.getAnimationDatastorages().size() > 0);
        setEnabledSortGUI(false);
        //sortCheckBox.setEnabled(true);
//        if(dsChain.getSize() == 0)
//            listBox.setVisible(false);
    }

    private void sort(){
        try{
            dsChain.sortValues(selectedFormat, bAsc.isSelected());
        }
        catch(Exception ex){//in case we throw an exception
            JOptionPane.showMessageDialog(
                    this,
                    i18n.get(this, "sortWarning", "Your data will not be sorted"),
                    i18n.get(this, "sortWarningTitle", "Format error"),
                    JOptionPane.WARNING_MESSAGE);
        }
    }

    /*public void setSelectedMode(AnimationDataStorage.Mode mode) {
    cbMode.setSelectedItem(mode);
    }*/
    private JPanel buildToolGUI() {
        JPanel tool = new JPanel();
        tool.setBackground(Color.GRAY);
        tool.setOpaque(false);
        nextButtonTool = new JButton(Util.loadIcon("FastForward16.png"));
        nextButtonTool.addActionListener(dsChain.getNextValueAction());

        bRunTool = new JToggleButton(Util.loadIcon("Play16.png"));
        bRunTool.setBackground(Color.gray);
        bRunTool.setOpaque(false);
        nextButtonTool.setBackground(Color.gray);
        nextButtonTool.setOpaque(false);
        nextButton.setToolTipText(i18n.get(AnimationDSChainPanel.class, "next", "Next value"));
        bRun.setToolTipText(i18n.get(AnimationDSChainPanel.class, "start", "Start"));
        bRunTool.setToolTipText(i18n.get(AnimationDSChainPanel.class, "start", "Start"));

        cbValuesTool = new JComboBox(dsChain.computeUnionValues().toArray());
        cbValuesTool.setSelectedItem(cbValues.getSelectedItem());
        cbValuesTool.addActionListener(manualActionListener);
        ComponentSizer.fixComponentSize(cbValues, new Dimension(120, 25));

        tool.add(cbValuesTool);
        tool.add(nextButtonTool);
        tool.add(bRunTool);
        /*manualActionListener = new ActionListener() {

        public void actionPerformed(ActionEvent e) {
        if (cbValuesTool.getSelectedItem() != null) {
        dsChain.nextStep(cbValuesTool.getSelectedItem().toString());
        }
        }
        };*/
        bRunTool.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                if (bRunTool.isSelected()) {
                    dsChain.start();
                    bRunTool.setIcon(Util.loadIcon("Pause16.png"));
                    bRun.setToolTipText(i18n.get(AnimationDSChainPanel.class, "stop", "Stop"));
                } else {
                    dsChain.stop();
                    bRunTool.setIcon(Util.loadIcon("Play16.png"));
                    bRunTool.setToolTipText(i18n.get(AnimationDSChainPanel.class, "sart", "Stop"));
                }
                bRunTool.updateUI();
            }
        });
        nextButtonTool.addActionListener(dsChain.getNextValueAction());

        return tool;

    }

    public void setEnabledManualNextButtons(boolean b){
        nextButton.setEnabled(b);
        nextButtonTool.setEnabled(b);
        if(dsChain.getSlave() != null){
            AnimationDSChainPanel adscp = (AnimationDSChainPanel)(dsChain.getSlave().getGUI());
            adscp.setEnabledManualNextButtons(b);
            adscp.setEnabledRunButton(b);
            cbValues.setEnabled(b);
            cbValuesTool.setEnabled(b);
        }
        
    }

    public void setEnabledRunButton(boolean b){
        bRun.setEnabled(b);
        bRunTool.setEnabled(b);
    }

    public JComponent getToolGUI() {
        return toolGUI;
    }

    public void refresh(boolean collect) {
        //System.out.println("REFRESH GUI ANIMATION DS CHAINNNNNNNNNNNN");
        activeListener = false;
        cbValues.removeAllItems();
        cbValuesTool.removeAllItems();
        Object[] newValues;
        if (collect) {
            newValues = dsChain.computeUnionValues().toArray();
        } else {
            newValues = dsChain.getValues().toArray();
        }
        //System.out.println("NEW VALUES  SIZE"+ newValues.length);
        for (Object o : newValues) {
            //System.out.println("AJOUT VALUE " + o);
            cbValues.addItem(o);
            cbValuesTool.addItem(o);
        }
        cbValues.setSelectedItem(dsChain.getCurrentValue());
        cbValues.updateUI();
        activeListener = true;
        //assignNextActionListenners();
    }

    public void removeAnimationFromGUI(MonoValuedFilterDataStorage ads) {
        if (animationsGUI.get(ads) != null) {
            listBox.remove(animationsGUI.get(ads));
            listBox.updateUI();
            animationsGUI.remove(ads);
        }
        updateUI();
//        if(dsChain.getSize() == 0){
//            System.out.println("REMOVE ANIMATION FROM GUI" + dsChain.getSize());
//            listBox.setVisible(false);
//        }
    }

    private void addAnimationCreationGUI() {
        if (pAddAnim == null) {
            pAddAnim = new JPanel();
            JLabel labNewAnimation = new JLabel(
                    i18n.get(AnimationDSChainPanel.class, "addAnimationTo", "Add an annimation to: "));

            final LayerHandler layerHandler = dsChain.getMetaAnimator().getLayerHandler();
            comboboxLayers = new JComboBox();
            //updateComboLayers(layerHandler.getLayers());
            layerHandler.addLayerListener(this);
            JButton bOk = new JButton(i18n.get(AnimationDSChainPanel.class, "ok", "Ok"));
            JButton bCancel = new JButton(i18n.get(AnimationDSChainPanel.class, "cancel", "Cancel"));
            pAddAnim.add(labNewAnimation);
            pAddAnim.add(comboboxLayers);
            pAddAnim.add(bOk);
            pAddAnim.add(bCancel);
            toolButtons.add(pAddAnim);
            toolButtons.updateUI();
            toolButtons.add(pAddAnim);
            ComponentSizer.fixComponentSize(comboboxLayers, new Dimension(120, 20));
            bOk.setBorder(null);
            bCancel.setBorder(null);
            bOk.setBackground(Color.LIGHT_GRAY);
            bCancel.setBackground(Color.LIGHT_GRAY);
            //mponentSizer.fixComponentSize(bOk, new Dimension(45, 25));
            ComponentSizer.fixComponentSize(pAddAnim, new Dimension(450, 25));
            pAddAnim.setBackground(Color.gray);
            pAddAnim.setOpaque(false);
            bOk.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent ae) {
                    pAddAnim.setVisible(false);
                    bNewAnim.setEnabled(true);
                    dsChain.addAnimationToLayer((Layer)comboboxLayers.getSelectedItem());
                    //addAnimationGUI(ads);
                }
            });
            bCancel.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent arg0) {
                    pAddAnim.setVisible(false);
                    bNewAnim.setEnabled(true);
                }
            });
        }
        pAddAnim.setVisible(true);
    }
/**
 * return true if the animation is selected in this chain
 * @param ads
 * @return
 */
    public void addAnimationGUI(final MonoValuedFilterDataStorage ads) {

        listBox.setVisible(true);
        final JPanel panAnim = new JPanel();
        final JComboBox adsGUI = (JComboBox) ads.getMetaGUI();
        final JCheckBox checkBox = new JCheckBox(ads.getFullName());
        panAnim.add(checkBox);
        panAnim.add(adsGUI);
        animationsGUI.put(ads, panAnim);
        ComponentSizer.fixComponentSize(checkBox, new Dimension(130, 25));
        ComponentSizer.fixComponentSize(adsGUI, new Dimension(100, 25));
        ComponentSizer.fixComponentSize(panAnim, new Dimension(280, 30));
        listBox.add(panAnim);
        adsGUI.setVisible(false);
        checkBox.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ae) {
                if (checkBox.isSelected()) {
                    dsChain.addAnimationDataStorage(ads);
                    checkBox.setToolTipText(i18n.get(AnimationDSChainPanel.this,"rmFilter","Remove filter from animation"));
                } else {
                    dsChain.removeAnimationDataStorage(ads);
                    checkBox.setToolTipText(i18n.get(AnimationDSChainPanel.this,"addFilter","Add filter to animation"));
                }
                if (panAnim.getComponentCount() == 1)
                    panAnim.add(adsGUI);
                adsGUI.setVisible(checkBox.isSelected());
                panAnim.updateUI();
                setEnabledParametersGUI(dsChain.getAnimationDatastorages().size() > 0);
            }
        });
        boolean contains = dsChain.getAnimationDatastorages().contains(ads);
        checkBox.setSelected(contains);
        checkBox.setToolTipText(checkBox.isSelected() ?
            i18n.get(AnimationDSChainPanel.this,"rmFilter","Remove filter to animation") :
            i18n.get(AnimationDSChainPanel.this,"addFilter","Add filter to animation"));
        adsGUI.setVisible(contains);
        if(contains){
            cbValues.setSelectedItem(ads.getFilterColumnValue());          
        }
        listBox.updateUI();
    }

    public void updateSelectedValue(String value) {
        cbValues.setSelectedItem(value);
        cbValues.updateUI();
        cbValuesTool.setSelectedItem(value);
        cbValuesTool.updateUI();
    }

    private void updateComboLayers(Layer[] layers) {
        ArrayList<Layer> lNames = new ArrayList<Layer>();
        for (Layer l : layers){
            if(l instanceof ThematicDataDisplayLayer){
                lNames.add(l);
            }
        }
        comboboxLayers.removeAllItems();
        for (Layer l : lNames)
            comboboxLayers.addItem(l);
    }

    protected void setDelay(int delay) {
        spinnerDelay.setValue(delay);
    }

    public void layerUpdate() {
        //throw new UnsupportedOperationException("Not supported yet.");
    }

    public void titleUpdate(String title) {
        ///throw new UnsupportedOperationException("Not supported yet.");
    }

    public void layerRemoved(Layer l) {
    }

    public void setLayers(LayerEvent le) {
        updateComboLayers(le.getLayers());
    }

    public void setEnabledParametersGUI(boolean b) {
        if(cbValues == null)
            return;
        cbValues.setEnabled(b);
        bRun.setEnabled(b);
        nextButton.setEnabled(b);
        spinnerDelay.setEnabled(b);
        //sortCheckBox.setEnabled(b);
        setEnabledSortGUI(b);

    }

    public void setEnabledSortGUI(boolean b) {

        /*if(b && sortCheckBox.isSelected())
        return;*/
        boxFormat.setEnabled(b);
        bAsc.setEnabled(b);
        bDesc.setEnabled(b);
        //bSort.setEnabled(b);


    }
}
