// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage;

import fr.unicaen.openmap.dataStorage.SortDataStorage.Format;

public class StringDataObjectComparator extends DataObjectComparator{

	public StringDataObjectComparator(String sortParameter, Format format) {
	    super(sortParameter, format);
	}
	
	public int compare(DataObject d1, DataObject d2){
	    if (sortParameter == null)
		return 0;
	    
	    Object data1 = d1.getData(sortParameter);
	    Object data2 = d2.getData(sortParameter);
	    return (data1.toString()).compareTo(data2.toString());
	}

}
