// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.gui;

import fr.unicaen.openmap.dataStorage.KernelGridDataStorage;
import fr.unicaen.openmap.dataStorage.gui.BoundingBoxPanel;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import javax.swing.Box;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
/**
 *
 * @author jchauvea
 */
public class KernelDataStoragePanel extends GridDataStoragePanel{

    protected JComboBox comboKernel;
    protected JSpinner spinRadius;


    public KernelDataStoragePanel(final KernelGridDataStorage ds){
        super(ds, false); // no Aggregate Function chooser
    }

    @Override
    protected JComponent buildTopPanel(){
        Box wrap = Box.createVerticalBox();
        wrap.add(super.buildTopPanel());
        JPanel pan = new JPanel();
        comboKernel = new JComboBox(KernelGridDataStorage.KernelType.values());
        comboKernel.addItemListener(new ItemListener() {
            public void itemStateChanged(ItemEvent arg0) {
                ((KernelGridDataStorage)gridDS).setKernelType((KernelGridDataStorage.KernelType)comboKernel.getSelectedItem());
            }
        });
        pan.add(new JLabel(i18n.get(KernelDataStoragePanel.class,"kernel","kernel")));
        pan.add(comboKernel);
        pan.add(new JLabel(i18n.get(KernelDataStoragePanel.class,"radius","Radius")));
        spinRadius = new JSpinner(new SpinnerNumberModel(((KernelGridDataStorage)gridDS).getRadius(), 0d, 90d, 1d));
	spinRadius.addChangeListener(new ChangeListener() {
            public void stateChanged(ChangeEvent e) {
                ((KernelGridDataStorage)gridDS).setRadius(((Double) spinRadius.getValue()).floatValue());
            }
        });
        pan.add(spinRadius);
	pan.add(new BoundingBoxPanel(((KernelGridDataStorage)gridDS).getKernelBoundingBox()));
        wrap.add(pan);
        return wrap;
    }
}
