/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.dataStorage.mif;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author jchauvea
 */
public class MidParser {

    //private String path;

    private String mifPath;

    private String midPath;

    private ArrayList<String> columnNames;

    private ArrayList<String> OMGraphicsNames;

    public final static String MID_EXTENSION = ".mid";

    public final static String MIF_EXTENSION = ".mif";

    public final static String MID_FIELD_SEPARATOR = ";";

    public final static String COLUMNS_PATTERN = "COLUMNS";

    public MidParser(String path) {
        //this.path = path;
        mifPath = path + MIF_EXTENSION;
        midPath = path + MID_EXTENSION;
        columnNames = new ArrayList<String>();
        OMGraphicsNames = new ArrayList<String>();
        OMGraphicsNames.add("the_geom");
    }

    public ArrayList<String> getColumnNames(){
        return columnNames;
    }

    public ArrayList<String> getOMGraphicsNames(){
        return OMGraphicsNames;
    }

    public ArrayList<ArrayList<Object>> parse() {
        parseColumnNames();
        ArrayList<ArrayList<Object>> midList = new ArrayList<ArrayList<Object>>();
        try {
            //System.out.println("MID PARSER -> " + midPath);
            BufferedReader in = new BufferedReader(new FileReader(midPath));
            String line;
            String[] tab;
            ArrayList<Object> tmpList;
            //boolean firstStep = true;
            while ((line = in.readLine()) != null) {
                tab = line.split(MID_FIELD_SEPARATOR);
                tmpList = new ArrayList<Object>();
                for(int i = 0 ; i < tab.length ; i++){
                    /*if(firstStep){
                        //String.valueOf(i)
                        columnNames.add(String.valueOf(i));
                    }*/
                    //System.out.println(tab[i]);
                    tmpList.add(tab[i]);
                }
                //firstStep = false;
                midList.add(tmpList);
            }
            in.close();
        } catch (IOException io) {
        }

        return midList;
    }

//    public ArrayList<ArrayList<Object>> parse() {
//
//    }
    private void parseColumnNames(){
        try {
            BufferedReader in = new BufferedReader(new FileReader(mifPath));
            String line;
            while ((line = in.readLine()) != null) {
                if(line.startsWith(COLUMNS_PATTERN))
                    break;
                else
                    continue;
            }
            int nbCols = Integer.parseInt(line.split(" ")[1]);
            int i = 0;
            while( i < nbCols){
                line = in.readLine();
                //System.out.println("line = " + line);
                 columnNames.add(line);
                 //System.out.println("col =" +line.split(" ")[1]);
                 i++;
            }
        } catch (Exception ex) {
            Logger.getLogger(MidParser.class.getName()).log(Level.SEVERE, null, ex);
        }

        

    }
//     public ArrayList<ArrayList<Object>> parseInMIF() {
//
//
//     }

}
