// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Properties;

import javax.swing.JCheckBox;
import javax.swing.JCheckBoxMenuItem;

import com.bbn.openmap.gui.menu.MapHandlerMenuItem;
import com.bbn.openmap.util.PropUtils;

import fr.unicaen.openmap.gui.dnd.MovableBox;

public class DisplayMenuItem extends JCheckBoxMenuItem implements ItemListener{
	

	
	protected MovableBox box;

	
	public DisplayMenuItem(String title){
		super(title);		
	}
	
	
	public void setCheckSelected(boolean b){
		setSelected(b);
		updateUI();
		addItemListener(this);
	}
	
	public void setBox(MovableBox box){
		this.box = box;	
	}

	public void itemStateChanged(ItemEvent e) {
		if (e.getStateChange() == ItemEvent.SELECTED) {
			box.externalize(new Point(1,1));
		}
		else{
			hideBox();
		}
		
	}
	
	public void hideBox(){
		if(!box.isExternalized())
			box.externalize(new Point(1,1));
		box.closeParent();
		box.getParentBoxContainer().removeElement(box);
		box.setExternalized(false);
		box.setHidden(true);
		box.hideEmptyTargets();
	}
}
