/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.gui;

import com.bbn.openmap.Layer;
import com.bbn.openmap.LayerHandler;
import fr.unicaen.openmap.AtlasLoader;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Thematic;
import java.awt.Component;
import java.io.File;
import java.util.Collections;
import java.util.HashMap;
import java.util.Vector;
import javax.swing.JComponent;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;

/**
 *
 * @author jchauvea
 */
public class NoDirectoriesAtlasLayersTree extends AtlasLayersTree {

    public NoDirectoriesAtlasLayersTree(DefaultMutableTreeNode root, String path,
            LayerHandler lh, JComponent comp) {
        super(root, path, lh, comp);
        this.setRootVisible(false);
    }

    public NoDirectoriesAtlasLayersTree(DefaultTreeModel model, LayerHandler lh, JComponent cp) {
        super(model, lh, cp);
        LayerCellRenderer renderer = new LayerCellRenderer();
        setCellRenderer(new LayerCellRenderer());
        setCellEditor(new LayerCellEditor(this, renderer));
    }

    /** Add nodes from under "dir" into top. Highly recursive. */
    @Override
    protected DefaultMutableTreeNode buildFileSystemTree(
            DefaultMutableTreeNode curTop, File dir) {
        String curPath = dir.getPath();
        DefaultMutableTreeNode curDir = null;
        if (curPath.contains(File.separator)) {
            String[] tab;
            if (File.separator.equals("\\")) {
                tab = curPath.split("\\" + File.separator);
            } else {
                tab = curPath.split("\\" + File.separator);
            }
            //curDir = buildNode(curPath, tab[tab.length - 1]);
            curDir = new DefaultMutableTreeNode(tab[tab.length - 1]);
        } else {
            curDir = new DefaultMutableTreeNode(curPath);
        }

        if (curTop != null) { // should only be null at root
            if (dir.isFile()) {
                curTop.add(curDir);
            }
        }
        Vector<String> ol = new Vector<String>();
        String[] tmp = dir.list();
        for (int i = 0; i < tmp.length; i++) {
            ol.addElement(tmp[i]);
        }
        Collections.sort(ol, String.CASE_INSENSITIVE_ORDER);
        File f;
        Vector<String> files = new Vector<String>();
        // Make two passes, one for Dirs and one for Files. This is #1.
        for (int i = 0; i < ol.size(); i++) {
            String thisObject = (String) ol.elementAt(i);
            String newPath;
            if (curPath.equals(".")) {
                newPath = thisObject;
            } else {
                newPath = curPath + File.separator + thisObject;
            }
            if ((f = new File(newPath)).isDirectory()) {
                buildFileSystemTree(curTop, f);
            } else {
                files.addElement(thisObject);
            }
        }
        // Pass two: for properties files.
        for (int fnum = 0; fnum < files.size(); fnum++) {
            if (files.elementAt(fnum).endsWith(AtlasLoader.PROPERTIES_EXTENSION)) {
                DefaultMutableTreeNode pNode = new DefaultMutableTreeNode(
                        files.elementAt(fnum).replace(AtlasLoader.PROPERTIES_EXTENSION, ""));

                curTop.add(pNode);

                String tmpPath = curPath + File.separator + files.elementAt(fnum);
//                if (!layersLoaded) {
//                    Layer[] ls = AtlasLoader.loadLayersFromPath(tmpPath, layerHandler);
//                    layersByPath.put(tmpPath, ls);
//                    buildTreeForLayers(pNode, ls);
//                } else {
                //layerHandler.removeLayer(layerHandler.getLayers().length -1 );
                Layer[] ls = AtlasLayersTree.layersByPath.get(tmpPath);
                if (ls != null) {
                    buildTreeForLayers(pNode, AtlasLayersTree.layersByPath.get(tmpPath));
                }
                // }
            }
        }

        return curDir;
    }
}
