// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui.component;


import javax.swing.JTable;
import javax.swing.event.ListSelectionEvent;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;

public class JComponentTable extends JTable{
	
	public JComponentTable(Object[][] data, String[] cols){
		super(data, cols);	
	}
	
	public JComponentTable(int rows ,int columns){
		super(rows, columns);
	}
	
	public JComponentTable(DefaultTableModel tableModel){
		super(tableModel);
	}
	
	public TableCellRenderer getCellRenderer(int row, int column) {
		TableColumn tableColumn = getColumnModel().getColumn(column);
		TableCellRenderer renderer = tableColumn.getCellRenderer();
		if (renderer == null) {
			Class c = getColumnClass(column);
			if( c.equals(Object.class) )
			{
				Object o = getValueAt(row,column);
				if( o != null )
					c = getValueAt(row,column).getClass();
			}
			renderer = getDefaultRenderer(c);
		}
		return renderer;
	}
	
	public TableCellEditor getCellEditor(int row, int column) {
		TableColumn tableColumn = getColumnModel().getColumn(column);
		TableCellEditor editor = tableColumn.getCellEditor();
		if (editor == null) {
			Class c = getColumnClass(column);
			if( c.equals(Object.class) )
			{
				Object o = getValueAt(row,column);
				if( o != null )
					c = getValueAt(row,column).getClass();
			}
			editor = getDefaultEditor(c);
		}
		return editor;
	}
	


	

}
