// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui.component;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JSplitPane;
import javax.swing.border.Border;
import javax.swing.plaf.basic.BasicSplitPaneDivider;
import javax.swing.plaf.basic.BasicSplitPaneUI;
import javax.swing.plaf.metal.MetalSplitPaneUI;

import fr.unicaen.openmap.util.Util;

public class ThemaMapSplitPane extends JSplitPane{

	private boolean oneTouchExpandable;
	
	
	public ThemaMapSplitPane(int type, Component c1, Component c2, boolean oneTouchExpandable){
		super(type, c1, c2);
		this.oneTouchExpandable = oneTouchExpandable;
		//setUI();
	}
	
	public ThemaMapSplitPane(boolean oneTouchExpandable){
		super();

	}
	
	public void setUI(){
		setDividerSize(8);
		MetalSplitPaneUI msp = new MetalSplitPaneUI() {
            public BasicSplitPaneDivider createDefaultDivider() {
            	BasicSplitPaneDivider bsd = new BasicSplitPaneDivider(this) {
            		protected JButton createLeftOneTouchButton(){
            			JButton b;
            			if(ThemaMapSplitPane.this.getOrientation() == JSplitPane.VERTICAL_SPLIT)
            				 b = new JButton(Util.loadIcon("splittop.png"));
            			else
            				 b = new JButton(Util.loadIcon("splitleft.png"));
            			b.setBorder(null);
            			b.setBackground(Color.LIGHT_GRAY);
            			b.setOpaque(false);
            			return b;

            		}
            		protected JButton createRightOneTouchButton(){
            			JButton b;
            			if(ThemaMapSplitPane.this.getOrientation() == JSplitPane.VERTICAL_SPLIT)
            				 b = new JButton(Util.loadIcon("splitbottom.png"));
            			else
            				 b = new JButton(Util.loadIcon("splitright.png"));
            			b.setBorder(null);
            			b.setBackground(Color.LIGHT_GRAY);
            			b.setOpaque(false);
            			return b;

            		}           		
            		
                    /*public void setBorder(Border b) {
                    	
                    }*/
                };
                bsd.setBorder(BorderFactory.createEmptyBorder(0,2,0,2));
                return bsd;
            }
           
        };
        msp.setContinuousLayout(false);
	    setUI(msp);
	    setBorder(null);
	}
	
	public void updateUI(){
		super.updateUI();
		//setUI();
	}

	@Override
	public void setLeftComponent(Component c){
		super.setLeftComponent(c);
		setOneTouchExpandable(mustShowButtons());
		
	}
	
	@Override
	public void setRightComponent(Component c){
		super.setRightComponent(c);
		setOneTouchExpandable(mustShowButtons());
		
	}
	
	private boolean mustShowButtons(){
		if(!oneTouchExpandable)
			return false;
		else{
			if(rightComponent == null || 
					!rightComponent.isVisible() ||
					leftComponent == null ||
					!rightComponent.isVisible())
				return false;
			else
				return true;
		}
	}
	
	public void hasChanged(){
		setOneTouchExpandable(mustShowButtons());
	}

}
