// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.dataDisplayLayer.gui;
import com.bbn.openmap.BasicI18n;
import com.bbn.openmap.I18n;
import java.awt.event.ActionEvent;
import javax.swing.*;

import fr.unicaen.openmap.layer.preLayer.UnicaenLayerListener;
import fr.unicaen.openmap.omGraphics.DrawingAttributes;
import fr.unicaen.openmap.util.*;
import java.util.Locale;


/**
 * This panel allows to repaint a layer «in live»
 */
public class ColorsPanel extends GraphicsPanel {
    private UnicaenLayerListener unicaenLayerListener = null;
      /**
     * Use I18N mecanism to allow internationalization.
     * Use I18N.properties file or I18N_fr_FR.properties for french version
     **/
    protected I18n i18n = new BasicI18n(new Locale("fr","FR"));
    
    public ColorsPanel(Colors colors) {
        super(new DrawingAttributes(false,false,false,false,false));
//        remove(fillModeCB);
//        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
//        panel.removeAll();
//        panel.setLayout(new LabeledPairLayout());
//
//        lineColorB = addButton("Couleur des limites", getColors().getLineColor());
//        fillColorB = addButton("Couleur de remplissage", getColors().getRealFillColor());
////        selectedLineColorB = addButton("«Negative» Line Color", colors.getSelectedLineColor());
////        selectedFillColorB = addButton("«Negative» Fill Color", colors.getSelectedFillColor());
//
//        add(panel);
//        add(new JActionButton("Ok") {
//            public void actionPerformed(ActionEvent ae) {
//                if (unicaenLayerListener!=null) unicaenLayerListener.refresh();
//            }
//        });
   }
        
     /**
     *  Add UnicaenLayerListener to refresh layer();
     */
    public void addUnicaenListener(UnicaenLayerListener ull){
        unicaenLayerListener=ull;
    }
    
    /**
     *  Remove the UnicaenLayerListener;
     */
    public void removeUnicaenListener(){
        unicaenLayerListener=null;
    }

}
