// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui;

/*
 * @author Jacques.Madelaine@info.unicaen.fr
 */

import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.TransferHandler;
import javax.swing.event.ChangeEvent;

import java.io.IOException;

import java.util.Enumeration;
import java.util.Vector;
import java.util.ArrayList;

import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.ColorScale;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.AttributesNames;


public class AttributesNamesColorScalePanel extends ColorScalePanel {

    public static final String LIST_PROPERTY_NAME = "list";
    
    /**
     * Available data column names.
     */
    protected Vector<String> available = new Vector<String>();

    /**
     * JList for available data column names.
     */
   // protected JList availableJL = new JList(available);// = new JList();

    /**
     * Used once to create available JList --due to crude refreshPanel()--. If it's not used, JList have multiple MouseAdpater and so...
     */
    private boolean needToRefresh = true;

    /**
     * AttributesNames associated. Provides column names and is updated if necessary.
     */
    protected AttributesNames attributesNames = null;


    public AttributesNamesColorScalePanel(ColorScale colorScale, AttributesNames attributesNames) {
	super(colorScale);
	this.attributesNames = attributesNames;
    }



    /**
     * Return the color button text.
     * @param i index for color button in inner colorButtons
     * @return String representation for color button text or empty String if index is not found.
     */    
    protected String getColorButtonText(int i) {
	// set colormap button text from the names
//	if (attributesNames != null && i < colorButtons.length && attributesNames.getName(i) != null)
//	    return attributesNames.getName(i);
	//return super.getColorButtonText(i);
        return "";
    }
    
    public void createOptionPanel() {
	
	//ad now to keep correct presentation
    JPanel panAvailalbeAndButtons = new JPanel(new GridLayout(1,2));
	/*Box box;
	box = Box.createVerticalBox();
	box.setBorder(BorderFactory.createTitledBorder(i18n.get(this, LIST_PROPERTY_NAME, "Available")));*/
	//box.add(new JScrollPane(availableJL));
	//add(box);
	
	/*JPanel pTransfertButtons = new JPanel(new GridLayout(2,1));
	JPanel pWrapButtons = new JPanel(new GridLayout(3,1));
	JButton bAdd = new JButton(">>");
	JButton bRm = new JButton("<<");

	JPanel pAdd = new JPanel();
	pAdd.add(bAdd);
	pTransfertButtons.add(pAdd);
	
	JPanel pRm = new JPanel();
	pRm.add(bRm);
	pTransfertButtons.add(pRm);
	pWrapButtons.add(new JPanel());
	pWrapButtons.add(pTransfertButtons);
	pWrapButtons.add(new JPanel());
	
	panAvailalbeAndButtons.add(box);
	panAvailalbeAndButtons.add(pWrapButtons);
	
	add(panAvailalbeAndButtons);*/
	
	//availableJL.setModel(available);
        //add(box);
	//color scale & buttons, etc.
	super.createOptionPanel();
	//final ListTransferHandler listTransfertHandler = new ListTransferHandler();
	//to avoid multiple listeners on jlist by using crude refreshPanel(). 
	//It works, but it's another thing to change later
	if (needToRefresh) {
	    //		availableJL.setDragEnabled(true); //useless here
		
	    //availableJL.setTransferHandler(listTransfertHandler);
	    /*availableJL.addMouseListener(new MouseAdapter() {
		    
		    //TO DO : modifier le Transferable pour ne pas passer le texte à n'importe quel élément
		    public void mousePressed(MouseEvent e) {
			JComponent c = (JComponent)e.getSource();
			TransferHandler handler = c.getTransferHandler();
			handler.exportAsDrag(c, e, TransferHandler.COPY);
		    }
		}
					 );*/
	    
	   /* availableJL.setToolTipText(i18n.get(this,
						LIST_PROPERTY_NAME, 
						I18n.TOOLTIP, 
						"drag and drop towards the color scale to select."));*/
	    needToRefresh = false;
	}
	
	//used by buttons. 
	final ButtonTransferHandler transferHandler = new ButtonTransferHandler();
	//Don't forget : buttons already have a MouseAdapter (button 1 => ColorChooser)
	//So it's essential to know when click and when drag
	MouseAdapter jbMA = new MouseAdapter() {
		
		boolean drag = false;
		boolean clic = false;
		JComponent c;
		
		public void mousePressed(MouseEvent e) {
		    //Maybe Ok to drag, but don't initiated here
		    drag = true;
		    c = (JComponent)e.getSource();
		    
		    /*todoif (c instanceof JButton && ((JButton)c).getText() != "")
		    	selectedButton = (JButton)c;*/
		}
		
		public void mouseExited(MouseEvent me) {
		    //The only moment to drag and drop
		    if (drag && c != null) {
			if (c instanceof JButton && ((JButton)c).getText() != "") {
			    
			    TransferHandler handler = c.getTransferHandler();
			    handler.exportAsDrag(c, me, TransferHandler.COPY);
			    drag = false;
			}
		    }
		}
		
		public void mouseReleased(MouseEvent e) {
		    //init
		    drag = false;
		    c = null;
		}
	    };
	//setPreferredSize(new Dimension(250,200));
        //setMaximumSize(new Dimension(250,200));
        int i =0;
	for(JButton button:colorButtons) {
            //JPanel p = new JPanel();
            if(button!=null){
            button.setMaximumSize(new Dimension(20,20));
            button.setPreferredSize(new Dimension(20,20));}
            /*todofor(int j = 0; j < available.size(); j++)
                colorCombos[i].addItem(available.get(j));
            colorCombos[i].setPreferredSize(new Dimension(120,20));
            colorCombos[i].setMaximumSize(new Dimension(120,20));
            colorCombos[i].addItemListener(new ItemListener() {
                public void itemStateChanged(ItemEvent ie) {
                    refresh();
                }
            });
            i++;*/
            /*p.add(cb);
            p.add(button);
            cb.setBackground(button.getBackground());
            box.add(p);*/
	    /*button.setTransferHandler(transferH,ndler);
	    button.addMouseListener(jbMA);*/
	}
	/*bAdd.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e) {
			if(availableJL.getSelectedValue()!=null){
				//selectedButton.setBorder(border);
				//selectedButton =null;
				transferHandler.importString(colorButtons[0], availableJL.getSelectedValue().toString());
				available.remove(availableJL.getSelectedIndex());
				availableJL.updateUI();
				}

		}	
	});*/
	
	/*bRm.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e) {
			if(selectedButton!=null){
				//String text = transferHandler.exportString(transferHandler.current);
				listTransfertHandler.importString(availableJL, selectedButton.getText());
				//transferHandler.cleanup(selectedButton, true);
				selectedButton.setText("");
				selectedButton.setBorder(border);
				selectedButton =null;
				
			}
	}	
});*/
	
    }

    /**
     * Sets the available names.
     * @param available new names
     */
    public void setAvailableNames(ArrayList<String> available) {
	this.available.clear();
	for (String a : available)
	    this.available.addElement(a);
	//	refresh();
    }

    /**
     * Used to JSpinner gestion. Forbidden to set number of buttons under text button number.
     */
    public void stateChanged(ChangeEvent e) {
	if(e.getSource() == colorNumber) { //We set the number of colors *only if* there's no risk to mask text
	    int n = ((Integer) colorNumber.getValue()).intValue();

	    ArrayList<String> v = new ArrayList<String>();
//	    for(int i = 0 ; i < colorButtons.length ; i++) {
//		if (colorButtons[i].getText() != "")
//		    v.add(colorButtons[i].getText());
//	    }
	    if (n < v.size()) {
		//System.out.println("AttributesNamesColorScalePanel : Not falling deeper");
		colorNumber.setValue(new Integer(v.size()));
	    } else {
		colorScale.setColorNumber(n);
		refreshPanel();	    
		return;
	    }
	}
    }

    /**
     * Used to have no blank in button text. Blank is for the end of list, if needs.
     * Data column names have changed : associated AttributesNames receive it.
     */
    public void refresh() {
	Vector<String> v = new Vector<String>();
//	for(int i = 0 ; i < colorButtons.length ; i++) {
//	    //if (colorButtons[i].getText() != "")
//            /*todoif (!colorCombos[i].getSelectedItem().toString().equals(""))
//		v.add(colorCombos[i].getSelectedItem().toString());*/
//	}

	Enumeration<String> elements = v.elements();
	String[] names = new String[v.size()];
	String element;
	//reorganization
//	for (int i = 0 ; i < colorButtons.length ; i++) {
//
//	    if (elements.hasMoreElements()) {
//		element = elements.nextElement();
//		colorButtons[i].setText(element);
//		names[i] = element;
//	    }
//	    else colorButtons[i].setText("");
//	}

	attributesNames.setAttributesNames(names);
	fireColorScaleChanged();
    }

    /**
     * Indicates is all boutons have text. Used to determinate if color buttons can received new text from JList.
     * @see ButtonTransferHandler#canImport(JComponent comp, DataFlavor[] transferFlavors)
     * @see ButtonTransferHandler#canImport(TransferHandler.TransferSupport support)
     * @return true if all buttons have text, false if not.
     */
    private boolean isFull() {
	int total = 0;
	for (JButton button:colorButtons) {
	    if (button.getText() != "")
		total++;
	}
	//return (total == colorButtons.length);
        return false;
    }


    // #################### Drag and drop ####################

    /**
     * MIME used for the customized Drag and Drop.
     */
    private static String MIME = DataFlavor.javaJVMLocalObjectMimeType +
	";class=" + AttributesNamesColorScalePanel.class.getName();
    
    private static DataFlavor attributesNamesFlavor = null;

    /**
     * DataFlavor can be used in Transferable.
     * @see AttributesNamesSelection
     */
    public static DataFlavor getFlavor() {

	try {
	    attributesNamesFlavor = new DataFlavor(MIME);
	}
	catch(ClassNotFoundException cnfe) {
	    cnfe.printStackTrace();
	}
	return attributesNamesFlavor;
    }

    @Override
    public void createColorScalePanel() {
        //throw new UnsupportedOperationException("Not supported yet.");
    }

  

    /**
     * For a selected transfer. Use a customized DataFlavor to avoid unwanted transfer.
     * @see AttributesNamesColorScalePanel#getFlavor()
     */
    public class AttributesNamesSelection implements Transferable {

	private String data;

	private final DataFlavor[] flavors = {
	    getFlavor()
	};
	
	/**
	 * Creates a <code>Transferable</code> capable of transferring
	 * the specified <code>String</code>.
	 */
	public AttributesNamesSelection(String data) {
	    this.data = data;
	}
	
	public DataFlavor[] getTransferDataFlavors() {
	    // returning flavors itself would allow client code to modify
	    // our internal behavior
	    return (DataFlavor[])flavors.clone();
	}
	
	public boolean isDataFlavorSupported(DataFlavor flavor) {
	    for (int i = 0; i < flavors.length; i++) {
		if (flavor.equals(flavors[i])) {
		    return true;
		}
	    }
	    return false;
	}
	
	public Object getTransferData(DataFlavor flavor)
	    throws UnsupportedFlavorException, IOException {
	    if (flavor.equals(getFlavor()))
		return data;
	    else
		throw new UnsupportedFlavorException(flavor);
	}
    }//AttributesNamesSelection 



    /**
     * Provided by ExtendedDnDDemo.java example in java tutorial. Adaptation.
     */
    public abstract class StringTransferHandler extends TransferHandler {
    
	protected abstract String exportString(JComponent c);
	protected abstract void importString(JComponent c, String str);
	protected abstract void cleanup(JComponent c, boolean remove);
	
	protected Transferable createTransferable(JComponent c) {
	    return new AttributesNamesSelection(exportString(c));
	}
	
	public int getSourceActions(JComponent c) {
	    return COPY_OR_MOVE;
	}
	
	public boolean importData(JComponent c, Transferable t) {
	    if (canImport(c, t.getTransferDataFlavors())) {
		try {
		    String str = (String) t.getTransferData(getFlavor());
		    importString(c, str);
		    return true;
		} catch (UnsupportedFlavorException ufe) {
		    System.err.println(ufe);
		} catch (IOException ioe) {
		    System.err.println(ioe);
		}
	    }
	    
	    return false;
	}
	
	protected void exportDone(JComponent c, Transferable data, int action) {

	    cleanup(c, action == MOVE);
	}
	
	public boolean canImport(JComponent c, DataFlavor[] flavors) {

	    for (int i = 0; i < flavors.length; i++) {
		if (getFlavor().equals(flavors[i])) {
		    return true;
		}
	    }
	    return false;
	}

	/**
	 * If all buttons have text, the only accepted import is between buttons.
	 */	
	public boolean canImport(TransferHandler.TransferSupport support) {
	    return canImport((JComponent) support.getComponent(), support.getDataFlavors());
	}
    }//end StringTransferHandler


    /*
     * Adaptation from ListTransferHandler.java in ExtendedDnDDemo.java example in java tutorial.
     */
    public class ListTransferHandler extends StringTransferHandler {
	private int[] indices = null;
	//	private int addIndex = -1; //Location where items were added
	//	private int addCount = 0;  //Number of items added.
	
	//Bundle up the selected items in the list
	//as a single string, for export.
	protected String exportString(JComponent c) {
	    JList list = (JList)c;
	    indices = list.getSelectedIndices();
	    Object[] values = list.getSelectedValues();
	    
	    StringBuffer buff = new StringBuffer();
	    
	    for (int i = 0; i < values.length; i++) {
		Object val = values[i];
		buff.append(val == null ? "" : val.toString());
		if (i != values.length - 1) {
		    buff.append("\n");
		}
	    }
	    
	    return buff.toString();
	}

	//Take the incoming string and wherever there is a
	//newline, break it into a separate item in the list.
	protected void importString(JComponent c, String str) {
	    JList target = (JList)c;
	    DefaultListModel listModel = (DefaultListModel)target.getModel();
	    int index = target.getSelectedIndex();
	    
	    //Prevent the user from dropping data back on itself.
	    //For example, if the user is moving items #4,#5,#6 and #7 and
	    //attempts to insert the items after item #5, this would
	    //be problematic when removing the original items.
	    //So this is not allowed.
	    if (indices != null && index >= indices[0] - 1 &&
		index <= indices[indices.length - 1]) {
		indices = null;
		return;
	    }
	    
	    //Original code. Useless here
	    /*        int max = listModel.getSize();
		      if (index < 0) {
		      index = max;
		      } else {
		      index++;
		      if (index > max) {
		      index = max;
		      }
		      }
		      addIndex = index;
		      String[] values = str.split("\n");
		      addCount = values.length;
		      for (int i = 0; i < values.length; i++) {
		      listModel.add(index++, values[i]);
		      }*/
	    listModel.add(listModel.getSize(), str);
	}

	//If the remove argument is true, the drop has been
	//successful and it's time to remove the selected items 
	//from the list. If the remove argument is false, it
	//was a Copy operation and the original list is left
	//intact.
	protected void cleanup(JComponent c, boolean remove) {
	    if (remove && indices != null) {
		JList source = (JList)c;
		DefaultListModel model  = (DefaultListModel)source.getModel();
		//If we are moving items around in the same list, we
		//need to adjust the indices accordingly, since those
		//after the insertion point have moved.
		/*            if (addCount > 0) {
			      for (int i = 0; i < indices.length; i++) {
			      if (indices[i] > addIndex) {
			      indices[i] += addCount;
                    }
		    }
		    }*/
		for (int i = indices.length - 1; i >= 0; i--) {
		    model.remove(indices[i]);

		}
	    }
	    
	    indices = null;
	    //	    addCount = 0;
	    //	    addIndex = -1;
	}
    }//ListTransferHandler


    /**
     * Not an adaptation, this time. Used to manage many drag and drop on color buttons.
     */
    public class ButtonTransferHandler extends StringTransferHandler {

	/**
	 * The current button used to export, if exists.
	 */
	JButton current = null;

	/**
	 * Indicates if transfer is on the same object.
	 */
	boolean noMove = false;
	
	protected String exportString(JComponent c) {
	    current = (JButton)c;
	    return current.getText();
	}
	
	protected void importString(JComponent c, String str) {
	    JButton target = (JButton)c;
	    
	    if (current == target) {//même bouton : rien faire
		noMove = true;
		return;
	    }
	    
	    if (current != null) {//entre bouton
		current.setText(target.getText());
		target.setText(str);
		
		current = target;
	    } else {//provenance : liste extérieure
		
		//pas de prise de tête : ajouter à emplacement vide
		/*	    for (JButton button:buttons) {
			    if (button.getText() == "") {
			    button.setText(str);
			    return;
			    }
			    }*/
				
		//obsolète : canImport filtre ça
		if (isFull())
		    return;
		
		//cas simple 
		if (target.getText() == "") {
		    target.setText(str);
		    refresh();
		    return;
		} 

		int index = -1;
		int i = 0;
		Vector<String> v = new Vector<String>();
		
//		for(i = 0 ; i < colorButtons.length ; i++) {
//		    if (colorButtons[i].getText() != "")
//			v.add(colorButtons[i].getText());
//
//		    if (colorButtons[i] == target) {
//			index = i;
//		    }
//		}
		v.insertElementAt(str, index);
		Enumeration<String> elements = v.elements();
		
		//réorganisation
		for (JButton button:colorButtons) {
		    if (elements.hasMoreElements())
			button.setText(elements.nextElement());
		    else button.setText("");
		}
		refresh();
	    }
	}

	protected void cleanup(JComponent c, boolean remove) {
	    JButton source = (JButton)c;
	    
	    if (remove) {
		if (!noMove && current == source)
		    source.setText("");
	    }
	    //réorganisation
	    current = null;
	    noMove = false;
	    refresh();
	}

	/**
	 * If all buttons have text, the only accepted import is between buttons.
	 */
	public boolean canImport(JComponent comp, DataFlavor[] transferFlavors) {
	    if (isFull() && current == null)
		return false;
	    return super.canImport(comp, transferFlavors);
	} 

	/**
	 * If all buttons have text, the only accepted import is between buttons.
	 */	
	public boolean canImport(TransferHandler.TransferSupport support) {
	    if (isFull() && current == null)
		return false;
	    return super.canImport(support);
	}
    }//ButtonTransferHandler

}
