// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.legend;

import java.awt.Color;
import java.util.ArrayList;
import javax.swing.*;
import java.awt.event.*;

import com.bbn.openmap.omGraphics.*;

import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.MouseControlPointsListener;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.legend.*;
import fr.unicaen.openmap.util.Util;

/**
 * A group of OMResizeableGraphic inside a frame that forwards extend to its content.
 */
public class OMResizeableExtensibleFrame extends OMResizeableFrame {

    public OMResizeableExtensibleFrame(Refreshable r, MouseControlPointsListener ml, int xAnchor, int yAnchor, int width, int height, String name) {
	super(r, ml, xAnchor, yAnchor, width, height, true, name);
    }
   
    public void extend(int dw, int dh) {
	super.extend(dw, dh);
	for (OMResizeableGraphic om : getResizeableGraphics())
	    om.extend(dw, dh);
    }


 }
