/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.legend;

import com.bbn.openmap.omGraphics.OMText;
import com.bbn.openmap.util.PropUtils;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.MouseControlPointsListener;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.ThematicConfPanel;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.Refreshable;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.ColorScale;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.MinMaxValues;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.Resizer;
import java.awt.Paint;
import java.util.Properties;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JScrollPane;

/**
 *
 * @author jchauvea
 */
public class OMResizeablePieLegend extends OMResizeableFrame {

    protected OMResizeableColorScaleLegend scl;
    protected OMResizeableDiscLegend discLegend = null;
    protected OMResizeablePie generalPie;
    protected OMResizeableText title;

    public OMResizeablePieLegend(Refreshable r, MouseControlPointsListener ml, int xAnchor, int yAnchor, Resizer resizer, double[] generalAngles, Paint lineColor, Paint fillColor, ColorScale colorScale, String[] colorNames, String name) {
        super(r, ml, xAnchor, yAnchor, 0, 0, true, name);
        init(resizer, generalAngles, lineColor, fillColor, colorScale, colorNames);
    }

    public OMResizeablePieLegend(Refreshable r, MouseControlPointsListener ml, int xAnchor, int yAnchor,Resizer resizer, double[] generalAngles, Paint lineColor, Paint fillColor, ColorScale colorScale, String[] colorNames, OMResizeableDiscLegend discLegend, String name) {
        super(r, ml, xAnchor, yAnchor, 0, 0, true, name);
        this.discLegend = discLegend;
        init(resizer, generalAngles, lineColor, fillColor, colorScale, colorNames);
    }

    public void init(Resizer resizer, double[] generalAngles, Paint lineColor, Paint fillColor, ColorScale colorScale, String[] colorNames) {
        
        final int offset = 15;
        int x0 = getXAnchor(), y0 = getYAnchor() + offset;
        if(discLegend != null) {
            add(discLegend);
            discLegend.translate(0, offset);
            y0 += discLegend.getHeight() + offset;
        }
        int generalPieRadius = 60;
        scl = new OMResizeableColorScaleLegend(refreshable, ml, x0, y0, colorScale, colorNames, "", "");
        add(scl);
        
        y0 += scl.getHeight() + offset;


        //y0 += title.getHeight() + offset;

        generalPie = new OMResizeablePie(refreshable, ml, x0 + generalPieRadius, y0 + generalPieRadius / 2, generalPieRadius, colorNames.length, generalAngles, colorScale, "");
        add(generalPie);

         y0 += generalPie.getHeight() / 2 + offset;
        title =
	    new OMResizeableText(refreshable, ml, x0, y0,
				 "Total", OMText.JUSTIFY_RIGHT, "Total");
        title.setFontStyle(java.awt.Font.BOLD);
        add(title);

        int w = Math.max(scl.getWidth(), Math.max(generalPie.getWidth(), discLegend == null ? 0 : discLegend.getWidth())) + 2*offset;
        int h = scl.getHeight() + generalPie.getHeight() + (discLegend == null ? 0 : discLegend.getHeight());

        extendBorder(w, h);

        if(discLegend != null)
            discLegend.translate((w - discLegend.getWidth()) / 2 , 0);
        scl.translate((w - scl.getWidth()) / 2 , 0);
        title.translate((w - title.getWidth()) / 2 , 0);
        generalPie.translate((w - generalPie.getWidth()) / 2 , 0);
    }


    public static final String GENERAL_PIE_PROPERTY_NAME = "general_pie";
    public static final String COLORS_PROPERTY_NAME = "colors";
    public static final String DISC_LEGEND_PROPERTY_NAME = "disc_legend";
    public static final String PIE_LEGEND_PROPERTY_NAME = "pie_legend";
    public static final String GENERAL_PIE_TITLE_PROPERTY_NAME = "general_pie_title";

    public void setProperties(String prefix, Properties properties) {
        super.setProperties(prefix, properties);
        prefix = PropUtils.getScopedPropertyPrefix(prefix + PIE_LEGEND_PROPERTY_NAME + ".") ;
        //System.out.println("SET PROPERTIES");
        scl.setProperties(prefix + COLORS_PROPERTY_NAME, properties);
        generalPie.setProperties(prefix + GENERAL_PIE_PROPERTY_NAME, properties);
        title.setProperties(prefix + GENERAL_PIE_TITLE_PROPERTY_NAME, properties);
        if(discLegend != null)
           discLegend.setProperties(prefix + DISC_LEGEND_PROPERTY_NAME, properties);

    }

    public Properties getProperties(String prefix, Properties properties) {
        properties = super.getProperties(prefix, properties);
        prefix = PropUtils.getScopedPropertyPrefix(prefix + PIE_LEGEND_PROPERTY_NAME +".") ;
        properties = scl.getProperties(prefix + COLORS_PROPERTY_NAME, properties);
        properties = generalPie.getProperties(prefix + GENERAL_PIE_PROPERTY_NAME, properties);
        properties = title.getProperties(prefix + GENERAL_PIE_TITLE_PROPERTY_NAME, properties);
        if(discLegend != null)
            properties = discLegend.getProperties(prefix + DISC_LEGEND_PROPERTY_NAME, properties);
        properties = scl.getProperties(prefix + COLORS_PROPERTY_NAME, properties);
        properties = generalPie.getProperties(prefix + GENERAL_PIE_PROPERTY_NAME, properties);
        properties = title.getProperties(prefix + GENERAL_PIE_TITLE_PROPERTY_NAME, properties);
        if(discLegend != null)
            properties = discLegend.getProperties(prefix + DISC_LEGEND_PROPERTY_NAME, properties);
        return properties;
    }

//    protected void visuFrameRefreshGUI() {
//        if (guiPanel == null) {
//            return;
//        }
//        guiPanel.removeAll();
//        ThematicConfPanel confp = ThematicConfPanel.createThematicConfPanel(getName());
//        guiContent = Box.createVerticalBox();
//        guiContent.add(getToolGUI());
//        for (OMResizeableGraphic omrg : getResizeableGraphics()) {
//            if (omrg != null) { // real self defense programming !-)
//                JComponent gui = omrg.getGUI();
//                if (gui != null) {
//                    guiContent.add(gui);
//                }
//            }
//        }
//        confp.setContent(new JScrollPane(
//                guiContent,
//                JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
//                JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED));
//        guiPanel.add(confp);
//        guiPanel.updateUI();
//    }
}
