// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.legend;

import com.bbn.openmap.omGraphics.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.*;

import javax.swing.*;
import java.awt.Color;
import java.awt.event.*;
import java.awt.Dimension;

public class OMResizeableRaster extends OMResizeableGraphic {
    OMRaster omRaster;
    public OMResizeableRaster(Refreshable r, MouseControlPointsListener ml, int x, int y, ImageIcon icon) { 
	super(r, ml, "");  // empty name as we don't want a GUI for it.
	omRaster = new OMRaster(x, y - icon.getIconHeight(), icon);
	addOMControlPoint(new OMControlNPoint(x + icon.getIconWidth()/2, y - icon.getIconHeight()/2, 
					      OMResizeableGraphic.OMControlPointRadius, 
					      Color.yellow, Color.red, refreshable.getMapBean()));
	add(omRaster);
    }
    public void translate(int dx, int dy) { 
	omRaster.setX(omRaster.getX()+dx); 
	omRaster.setY(omRaster.getY()+dy); 
	for(int i = 0; i < omControlPoints.size(); i++) 
	    ((OMControlPoint)omControlPoints.getOMGraphicAt(i)).translate(dx, dy);
    }
    public void extend(int dw, int dh) {}
    public int getXAnchor() { return omRaster.getX(); }
    public int getYAnchor() { return omRaster.getY(); }
    public int getWidth() { return omRaster.getWidth(); }
    public int getHeight() { return omRaster.getHeight(); }

    protected JComponent guiPanel = null;
    public JComponent getGUI() {
	if (guiPanel == null)
	    guiPanel = Box.createHorizontalBox();
	refreshGUI();
	return guiPanel;
    }

    protected void refreshGUI() {
	if (guiPanel == null)
	    return;
	guiPanel.removeAll();
	final JCheckBox visibleCB = new JCheckBox("", true);
	visibleCB.setToolTipText("disable");
	visibleCB.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    visibleCB.setToolTipText(visibleCB.isSelected() ? "disable" : "enable");
		    setGraphicsVisible(visibleCB.isSelected());
		    refreshGraphics();
		}
	    });
	guiPanel.add(visibleCB); 
	guiPanel.add(Box.createRigidArea(new Dimension(5, 0)));
	guiPanel.add(new JLabel(" Select icon (will be soon available...)"));
    }
}

