// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util;

import java.awt.Font;
import javax.swing.JButton;

/**
 * This class provides a JButton with an associated Font.
 */
public class FontButton extends JButton {
    
    private Font associatedFont;
    
    public FontButton(Font font) {
	super();
	setAssociatedFont((font != null) ? font : new Font ("Arial", 1, 12));
    }
    
    public void setAssociatedFont(Font font) {
	associatedFont = font;
	setFont(associatedFont.deriveFont(12.0f));
	setText(associatedFont.getName() + " [" + font.getSize() + "]");
    }
    
    public Font getAssociatedFont() { return associatedFont; }
}
